<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

// Make sure the user is authorized to view this page
$user = & JFactory::getUser();
if (!$user->authorize( 'com_modules', 'manage' )) {
	$mainframe->redirect( 'index.php', JText::_('ALERTNOTAUTH') );
}

jimport('joomla.application.component.controller');

require_once (JPATH_COMPONENT.DS.'models'.DS.'counters.php');
require_once (JPATH_COMPONENT.DS.'models'.DS.'counterreport.php');

/**
 * VVisitCounterController
 *
 * @version $Id: counters.php 106 2010-04-04 08:24:54Z mmicha $
 * @package COM_VVISIT_COUNTER
 * @copyright Copyright (C) 2010 Majunke Michael majunke@mmajunke.de
 * @access public
 */
class VVisitCounterController extends JController
{

	/**
	 * Custom Constructor
	 */
	function __construct( $default = array())
	{
		parent::__construct( $default );

        $this->registerTask( 'reportCounter', 'reportCounter');
		$this->registerTask( 'emptyCounter',  'emptyCounter');
		$this->registerTask( 'truncateCounter', 'truncateCounter');

	}

	function display( )
	{

		switch($this->getTask())
		{
			case 'emptyCounter'    :
			{
				JRequest::setVar( 'hidemainmenu', 0 );
				JRequest::setVar( 'view', 'counters'  );
			} break;

			case 'truncateCounter' :
			{
				JRequest::setVar( 'hidemainmenu', 0 );
				JRequest::setVar( 'view', 'counters'  );
			} break;
		}

		//Set the default view, just in case
		$view = JRequest::getCmd('view');
		if(empty($view)) {
			JRequest::setVar('view', 'counters');
		};

		parent::display();
	}

    /**
     *
     */
    public function reportCounter(){

  		$array	= JRequest::getVar('cid', array(0), '', 'array');
        $this->setRedirect(
            'index.php?option=com_vvisitcounter&controller=counterreport&task=all&cid[]=' . $array[0]
        );

    }


	/**
	 * VVisitCounterControllerCounter::emptyCounter()
	 *
	 * @return
	 */
	public function emptyCounter()
	{

		$cid		= JRequest::getVar( 'cid', array(), '', 'array' );
		$task		= JRequest::getCmd( 'task' );

		$n			= count( $cid );
		if (count( $cid ) < 1) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

//        $model = $this->getModel('Counters');
//        $da = $model->getData();
//        $msg = "--" . $cid[0] ;
//        for ($i=0, $n=count( $da ); $i < $n; $i++) {
//                $row = &$da[$i];
//                $msg = $msg . "--" . $row->id;
//        }

        $model = $this->getModel('Counters');
        $msg = "Result: " . $model->emptyCounter( $cid[0] );
		$this->setRedirect( 'index.php?option=com_vvisitcounter', $msg );

	}

	/**
	 * VVisitCounterControllerCounter::truncateCounter()
	 *
	 * @return
	 */
	public function truncateCounter()
	{

		$cid		= JRequest::getVar( 'cid', array(), '', 'array' );
		$task		= JRequest::getCmd( 'task' );

		$n			= count( $cid );
		if (count( $cid ) < 1) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

//        $model = $this->getModel('Counters');
//        $da = $model->getData();
//        $msg = "--" . $cid[0] ;
//        for ($i=0, $n=count( $da ); $i < $n; $i++) {
//                $row = &$da[$i];
//                $msg = $msg . "--" . $row->id;
//        }

        $model = $this->getModel('Counters');
        $msg = "Result: " . $model->truncateCounter( $cid[0] );
		$this->setRedirect( 'index.php?option=com_vvisitcounter', $msg );

	}

}
?>
