<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

// Make sure the user is authorized to view this page
$user = & JFactory::getUser();
if (!$user->authorize( 'com_modules', 'manage' )) {
	$mainframe->redirect( 'index.php', JText::_('ALERTNOTAUTH') );
}

jimport('joomla.application.component.model');
jimport('joomla.html.parameter');

// require_once (JPATH_COMPONENT.DS.'helper'.DS.'helper.php');

/**
 * VVisitCounterModelCounters
 *
 * @version $Id: counters.php 106 2010-04-04 08:24:54Z mmicha $
 * @package COM_VVISIT_COUNTER
 * @copyright Copyright (C) 2010 Majunke Michael majunke@mmajunke.de
 * @access public
 */
class VVisitCounterModelCounters extends JModel {

	const PARAM_CREATETABLENAME = 's_createtableName';

    private $_data;

    /**
     * VVisitCounterModelCounters::getData()
     *
     * @return
     */
    public function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty($this->_data)) {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList($query);
        }

        if (!empty($this->_data)) {
            for ($i = 0, $n = count($this->_data); $i < $n; $i++) {
                $row = &$this->_data[$i];
                $this->fillAdditionalInfos($row);
            }
        }
        return $this->_data;
    }


     /**
     * VVisitCounterModelCounters::emptyCounter()
     *
     * Completly Clearing and Reseting Countertable
     *
     * @return
     */
    public function truncateCounter( $id = null ){

        $toEmpty = $this->getDataById( $id );
        if ( !empty ($toEmpty) && !empty($toEmpty->paramCreatetableName)){

            $sqlE = "TRUNCATE #__" . $toEmpty->paramCreatetableName ;
            $this->_db->setQuery( $sqlE );
            $this->_db->query();

            // FIXME ERRORS
            if ( $this->_db->getErrorNum() ) {
                return  $this->_db->getErrorMsg() ;
            }

            $result = "OK" ;
            return $result ;

        }
        else {
            return "Failed";
        }

    }

     /**
     * VVisitCounterModelCounters::emptyCounter()
     *
     * Clear Data but leave last Autoincrement ID unchanged
     *
     * @return
     */
    public function emptyCounter( $id = null ){

        $toEmpty = $this->getDataById( $id );
        if ( !empty ($toEmpty) && !empty($toEmpty->paramCreatetableName)){

            $sqlE = "DELETE FROM #__" . $toEmpty->paramCreatetableName ;
            $this->_db->setQuery( $sqlE );
            $this->_db->query();

            // FIXME ERRORS
            if ( $this->_db->getErrorNum() ) {
                return  $this->_db->getErrorMsg() ;
            }

            $result = $this->_db->getAffectedRows() ;
            return $result ;

        }
        else {
            return -1;
        }

    }



    /**
     * VVisitCounterModelCounters::fillAdditionalInfos()
     *
     * @param mixed $counter
     * @return
     */
    protected function fillAdditionalInfos( $counter ){

        $counter->paramCreatetableName =
            // strtolower( nein
                $this->_getModuleParam( $counter->params, self::PARAM_CREATETABLENAME );
            // );
        $counter->entries =
            $this->_counterEntries( $counter->paramCreatetableName );

		$counter->daysGes =
            $this->_counterDaysOverAll( $counter->paramCreatetableName );

    }


    /**
     * VVisitCounterModelCounters::getData()
     *
     * @return
     */
    protected function getDataById( $id )
    {

        $query = $this->_buildQuery($id);

        $this->_db->setQuery( $query );
		$this->_db->query();

        $result = $this->_db->loadObject();

        if (!empty( $result )) {
            $this->fillAdditionalInfos($result);
        }
        return $result;
    }


    /**
     * VVisitCounterModelCounters::_counterDaysOverAll()
     *
     * @param mixed $countertable
     * @return
     */
    protected function _counterDaysOverAll( $countertable )
    {
    	// $countertable = strtolower($countertable); nein

		// Table vorhanden ?
		if ( ! $this->_tableExist( $countertable ) ) {
			return -1;
		}

        $query = $this->_buildQueryCounterDaysOverAll($countertable);
        $entries = $this->_getListCount($query);
		return $entries;
    }

    /**
     * VVisitCounterModelCounters::_counterEntries()
     *
     * @param mixed $countertable
     * @return
     */
    protected function _counterEntries( $countertable )
    {
    	// $countertable = strtolower($countertable); nein

		// Table vorhanden ?
		if ( ! $this->_tableExist( $countertable ) ) {
			return -1;
		}

		$query = $this->_buildQueryCounterEntries($countertable);
        $entries = $this->_getListCount($query);
		return $entries;
    }


    /**
     * VVisitCounterModelCounters::_buildQueryCounter()
     *
     * @return
     */
    protected function _buildQueryCounterDaysOverAll( $countertable )
    {

    	// $countertable = strtolower($countertable); nein

		//$query = " SELECT count ( distinct DATE(FROM_UNIXTIME(tm)) ) as tmd " .
		$query = " SELECT distinct DATE(FROM_UNIXTIME(tm)) as tmd " .
		         " FROM #__" . $countertable ;
		return $query;

    }

    /**
     * VVisitCounterModelCounters::_buildQueryCounter()
     *
     * @return
     */
    protected function _buildQueryCounterEntries( $countertable )
    {

    	// $countertable = strtolower($countertable); nein

        //$query = " SELECT count(*) FROM #__".countertable." ";
        $query = " SELECT * FROM #__" . $countertable ;
        return $query;
    }

    /**
     * VVisitCounterModelCounters::_buildQuery()
     *
     * @return
     */
    protected function _buildQuery(  $id = null  )
    {
        if ( empty ($id )){
            $query = " SELECT * FROM #__modules where module = 'mod_vvisit_counter' ";
        }
        else {
            $query = " SELECT * FROM #__modules where module = 'mod_vvisit_counter' and id = " . $id ;
        }
        return $query;
    }

    /**
     * VVisitCounterModelCounters::_getModuleParam()
     *
     * @param mixed $modParams
     * @param mixed $paramSearch
     * @return
     */
    protected function _getModuleParam( $modParams , $paramSearch ){
        // Get module parameters - need Table
		$params = new JParameter( $modParams );
		return $params->get($paramSearch);
	}


	/**
	 * VVisitCounterModelCounters::checkTableExist()
	 *
	 * @param mixed $tables
	 * @param mixed $countertable
	 * @return
	 */
	protected function _tableExist( $countertable ){

		$db = JFactory::getDBO();
		$tables = $db->getTableList();

		$ok = false ;
		foreach($tables as $table){
    		if ( strcasecmp ( $db->getPrefix() . $countertable , $table ) == 0 ) {
    			$ok = true;
				break;
			}
    	}
		return $ok;

	}

}
